Index: palm/trunk/UTIL/inifor/src/transform.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/transform.f90	(revision 3178)
+++ palm/trunk/UTIL/inifor/src/transform.f90	(revision 3182)
@@ -21,4 +21,7 @@
 ! Current revisions:
 ! -----------------
+! Introduced new PALM grid stretching
+! Removed unnecessary subroutine parameters
+! Renamed kcur to k_intermediate
 ! 
 ! 
@@ -80,15 +83,13 @@
        TYPE(grid_definition), INTENT(IN) ::  outgrid
        REAL(dp), INTENT(IN)              ::  in_arr(0:,0:,0:)
-       REAL(dp), INTENT(OUT)             ::  out_arr(0:,0:,0:)
-
-       INTEGER :: i, j, k, l, nx, ny, nz
-
-       nx = UBOUND(out_arr, 1)
-       ny = UBOUND(out_arr, 2)
+       REAL(dp), INTENT(OUT)             ::  out_arr(0:,0:,:)
+
+       INTEGER :: i, j, k, l, nz
+
        nz = UBOUND(out_arr, 3)
 
-       DO j = 0, ny
-       DO i = 0, nx
-       DO k = nz, 0, -1
+       DO j = LBOUND(out_arr, 2), UBOUND(out_arr, 2)
+       DO i = LBOUND(out_arr, 1), UBOUND(out_arr, 1)
+       DO k = nz, LBOUND(out_arr, 3), -1
 
           ! TODO: Remove IF clause and extrapolate based on a critical vertical
@@ -101,6 +102,6 @@
              out_arr(i,j,k) = 0.0_dp
              DO l = 1, 2
-                out_arr(i,j,k) = out_arr(i,j,k) +                                 &
-                    outgrid % w_verti(i,j,k,l) *                                  &
+                out_arr(i,j,k) = out_arr(i,j,k) +                              &
+                    outgrid % w_verti(i,j,k,l) *                               &
                     in_arr(i,j,outgrid % kk(i,j,k, l) )
              END DO
@@ -139,7 +140,7 @@
     ! I index 0-based for the indices of the outvar to be consistent with the
     ! outgrid indices and interpolation weights.
-       TYPE(grid_definition), INTENT(IN) ::  outgrid
-       REAL(dp), INTENT(IN)              ::  invar(0:,0:,0:)
-       REAL(dp), INTENT(OUT)             ::  outvar(0:,0:,0:)
+       TYPE(grid_definition), INTENT(IN)  ::  outgrid
+       REAL(dp), INTENT(IN)               ::  invar(0:,0:,0:)
+       REAL(dp), INTENT(OUT)              ::  outvar(0:,0:,0:)
        TYPE(nc_var), INTENT(IN), OPTIONAL ::  ncvar
 
@@ -413,4 +414,5 @@
 
     END SUBROUTINE rotate_to_cosmo
+       
 
 
@@ -427,6 +429,6 @@
 !>                     -------------
 !>           jj, lat
-!>              ^      j
-!>              |       \          i
+!>              ^        j
+!>              |         \          i
 !>  jj(i,j,2/3) + ... 2 ---\--------/------ 3
 !>              |     | ^   \      /        |
@@ -459,10 +461,11 @@
 !> 
 !------------------------------------------------------------------------------!
-    SUBROUTINE find_horizontal_neighbours(cosmo_lat, cosmo_lon, cosmo_dxi,     &
-       cosmo_dyi, palm_clat, palm_clon, palm_ii, palm_jj)
+    SUBROUTINE find_horizontal_neighbours(cosmo_lat, cosmo_lon,                &
+                                          palm_clat, palm_clon,                &
+                                          palm_ii, palm_jj)
 
        REAL(dp), DIMENSION(0:), INTENT(IN)        ::  cosmo_lat, cosmo_lon
        REAL(dp), DIMENSION(0:,0:), INTENT(IN)     ::  palm_clat, palm_clon
-       REAL(dp), INTENT(IN)                       ::  cosmo_dxi, cosmo_dyi
+       REAL(dp)                                   ::  cosmo_dxi, cosmo_dyi
        INTEGER, DIMENSION(0:,0:,1:), INTENT(OUT)  ::  palm_ii, palm_jj
 
@@ -472,4 +475,6 @@
        lon0 = cosmo_lon(0)
        lat0 = cosmo_lat(0)
+       cosmo_dxi = 1.0_dp / (cosmo_lon(1) - cosmo_lon(0))
+       cosmo_dyi = 1.0_dp / (cosmo_lat(1) - cosmo_lat(0))
 
        DO j = 0, UBOUND(palm_clon, 2)!palm_grid % ny
@@ -508,5 +513,5 @@
        TYPE(grid_definition), INTENT(IN)    ::  palm_intermediate
 
-       INTEGER  ::  i, j, k, nx, ny, nz, nlev, kcur
+       INTEGER  ::  i, j, k, nx, ny, nz, nlev, k_intermediate
        LOGICAL  ::  point_is_below_grid, point_is_above_grid,                  &
                     point_is_in_current_cell
@@ -523,5 +528,5 @@
        DO j = 0, ny
 
-          kcur = 0
+          k_intermediate = 0
 
           column_base = palm_intermediate % h(i,j,0)
@@ -532,11 +537,11 @@
           ! cell, or above column_top. Keep increasing current cell index until
           ! the current cell overlaps with the current_height.
-          DO k = 0, nz
+          DO k = 1, nz
 
              ! Memorize the top and bottom boundaries of the coarse cell and the
              ! current height within it
              current_height = palm_grid % z(k) + palm_grid % z0
-             h_top    = palm_intermediate % h(i,j,kcur+1)
-             h_bottom = palm_intermediate % h(i,j,kcur)
+             h_top    = palm_intermediate % h(i,j,k_intermediate+1)
+             h_bottom = palm_intermediate % h(i,j,k_intermediate)
 
              point_is_above_grid = (current_height > column_top) !22000m, very unlikely
@@ -556,4 +561,7 @@
                 palm_grid % w_verti(i,j,k,1:2) = - 2.0_dp
 
+                message = "PALM-4U grid extends above COSMO-DE model top."
+                CALL abort('find_vertical_neighbours_and_weights', message)
+
              ELSE IF (point_is_below_grid)  THEN
 
@@ -564,9 +572,9 @@
                 ! cycle through intermediate levels until current
                 ! intermediate-grid cell overlaps with current_height
-                DO WHILE (.NOT. point_is_in_current_cell .AND. kcur <= nlev-1)
-                   kcur = kcur + 1
-
-                   h_top    = palm_intermediate % h(i,j,kcur+1)
-                   h_bottom = palm_intermediate % h(i,j,kcur)
+                DO WHILE (.NOT. point_is_in_current_cell .AND. k_intermediate <= nlev-1)
+                   k_intermediate = k_intermediate + 1
+
+                   h_top    = palm_intermediate % h(i,j,k_intermediate+1)
+                   h_bottom = palm_intermediate % h(i,j,k_intermediate)
                    point_is_in_current_cell = (                                &
                       current_height >= h_bottom .AND.                         &
@@ -575,13 +583,14 @@
                 END DO
 
-                ! kcur = 48 indicates the last section (indices 48 and 49), i.e.
-                ! kcur = 49 is not the beginning of a valid cell.
-                IF (kcur > nlev-1)  THEN
-                   message = "Index " // TRIM(str(kcur)) // " is above intermediate grid range."
+                ! k_intermediate = 48 indicates the last section (indices 48 and 49), i.e.
+                ! k_intermediate = 49 is not the beginning of a valid cell.
+                IF (k_intermediate > nlev-1)  THEN
+                   message = "Index " // TRIM(str(k_intermediate)) //          &
+                             " is above intermediate grid range."
                    CALL abort('find_vertical_neighbours', message)
                 END IF
    
-                palm_grid % kk(i,j,k,1) = kcur
-                palm_grid % kk(i,j,k,2) = kcur + 1
+                palm_grid % kk(i,j,k,1) = k_intermediate
+                palm_grid % kk(i,j,k,2) = k_intermediate + 1
 
                 ! copmute vertical weights
@@ -643,8 +652,8 @@
 !          
     SUBROUTINE compute_horizontal_interp_weights(cosmo_lat, cosmo_lon,         &
-       cosmo_dxi, cosmo_dyi, palm_clat, palm_clon, palm_ii, palm_jj, palm_w_horiz)
+       palm_clat, palm_clon, palm_ii, palm_jj, palm_w_horiz)
        
        REAL(dp), DIMENSION(0:), INTENT(IN)        ::  cosmo_lat, cosmo_lon
-       REAL(dp), INTENT(IN)                       ::  cosmo_dxi, cosmo_dyi
+       REAL(dp)                                   ::  cosmo_dxi, cosmo_dyi
        REAL(dp), DIMENSION(0:,0:), INTENT(IN)     ::  palm_clat, palm_clon
        INTEGER, DIMENSION(0:,0:,1:), INTENT(IN)   ::  palm_ii, palm_jj
@@ -654,4 +663,7 @@
        REAL(dp) ::  wl, wp
        INTEGER  ::  i, j
+
+       cosmo_dxi = 1.0_dp / (cosmo_lon(1) - cosmo_lon(0))
+       cosmo_dyi = 1.0_dp / (cosmo_lat(1) - cosmo_lat(0))
 
        DO j = 0, UBOUND(palm_clon, 2)
Index: palm/trunk/UTIL/inifor/src/types.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/types.f90	(revision 3178)
+++ palm/trunk/UTIL/inifor/src/types.f90	(revision 3182)
@@ -21,4 +21,9 @@
 ! Current revisions:
 ! -----------------
+! Introduced new PALM grid stretching:
+! - Converted vertical grid_definition coordinte variables to pointers
+! Improved command line interface:
+! - Moved INIFOR configuration into a new derived data type
+! Removed unnecessary variables 
 ! 
 ! 
@@ -41,9 +46,34 @@
  
  USE defs,                                                                     &
-    ONLY:  dp, PATH, SNAME, LNAME
+    ONLY:  dp, DATE, PATH, SNAME, LNAME
  USE netcdf,                                                                   &
     ONLY:  NF90_MAX_VAR_DIMS, NF90_MAX_NAME
 
  IMPLICIT NONE
+
+ TYPE inifor_config
+    CHARACTER(LEN=DATE)  ::  start_date           !< String of the FORMAT YYYYMMDDHH indicating the start of the intended PALM-4U simulation
+
+    CHARACTER(LEN=PATH)  ::  input_path           !< Path to the input data file directory
+    CHARACTER(LEN=PATH)  ::  hhl_file             !< Path to the file containing the COSMO-DE HHL variable (height of half layers, i.e. vertical cell faces)
+    CHARACTER(LEN=PATH)  ::  namelist_file        !< Path to the PALM-4U namelist file
+    CHARACTER(LEN=PATH)  ::  output_file          !< Path to the INIFOR output file (i.e. PALM-4U dynamic driver')
+    CHARACTER(LEN=PATH)  ::  soiltyp_file         !< Path to the file containing the COSMO-DE SOILTYP variable (map of COSMO-DE soil types)
+    CHARACTER(LEN=PATH)  ::  static_driver_file   !< Path to the file containing the COSMO-DE SOILTYP variable (map of COSMO-DE soil types)
+
+    CHARACTER(LEN=SNAME) ::  flow_prefix          !< Prefix of flow input files, e.g. 'laf' for COSMO-DE analyses
+    CHARACTER(LEN=SNAME) ::  soil_prefix          !< Prefix of soil input files, e.g. 'laf' for COSMO-DE analyses
+    CHARACTER(LEN=SNAME) ::  radiation_prefix     !< Prefix of radiation input files, e.g 'laf' for COSMO-DE analyses
+    CHARACTER(LEN=SNAME) ::  soilmoisture_prefix  !< Prefix of input files for soil moisture spin-up, e.g 'laf' for COSMO-DE analyses
+
+    CHARACTER(LEN=SNAME) ::  bc_mode
+    CHARACTER(LEN=SNAME) ::  ic_mode
+    CHARACTER(LEN=SNAME) ::  rotation_method
+
+    REAL(dp)             ::  p0
+    REAL(dp)             ::  ug
+    REAL(dp)             ::  vg
+    REAL(dp)             ::  z0 !< Elevation of the PALM-4U domain above sea level [m]
+ END TYPE inifor_config
 
  TYPE grid_definition
@@ -55,13 +85,6 @@
     INTEGER, ALLOCATABLE  ::  jj(:,:,:)     !< Given a point (i,j,k) in the PALM-4U grid, jj(i,j,l) gives the y index of the l'th horizontl neighbour on the COSMO-DE grid.
     INTEGER, ALLOCATABLE  ::  kk(:,:,:,:)   !< Given a point (i,j,k) in the PALM-4U grid, kk(i,j,k,l) gives the z index of the l'th vertical neighbour in the intermediate grid.
-    REAL(dp)              ::  dx            !< grid spacing in the first dimension [m]
-    REAL(dp)              ::  dy            !< grid spacing in the second dimension [m]
-    REAL(dp)              ::  dz            !< grid spacing in the third dimension [m]
-    REAL(dp)              ::  dxi           !< inverse grid spacing in the first dimension [m^-1]
-    REAL(dp)              ::  dyi           !< inverse grid spacing in the second dimension [m^-1]
-    REAL(dp)              ::  dzi           !< inverse grid spacing in the third dimension [m^-1]
     REAL(dp)              ::  lx            !< domain length in the first dimension [m]
     REAL(dp)              ::  ly            !< domain length in the second dimension [m]
-    REAL(dp)              ::  lz            !< domain length in the third dimension [m]
     REAL(dp)              ::  x0            !< x coordinate of PALM-4U domain projection centre, i.e. location of zero distortion
     REAL(dp)              ::  y0            !< y coordinate of PALM-4U domain projection centre, i.e. location of zwro distortion
@@ -69,5 +92,5 @@
     REAL(dp), ALLOCATABLE ::  x(:)          !< coordinates of cell centers in x direction [m]
     REAL(dp), ALLOCATABLE ::  y(:)          !< coordinates of cell centers in y direction [m]
-    REAL(dp), ALLOCATABLE ::  z(:)          !< coordinates of cell centers in z direction [m]
+    REAL(dp), POINTER     ::  z(:)          !< coordinates of cell centers in z direction [m]
     REAL(dp), ALLOCATABLE ::  h(:,:,:)      !< heights grid point for intermediate grids [m]
     REAL(dp), POINTER     ::  hhl(:,:,:)    !< heights of half layers (cell faces) above sea level in COSMO-DE, read in from 
@@ -76,5 +99,5 @@
     REAL(dp), ALLOCATABLE ::  xu(:)         !< coordinates of cell faces in x direction [m]
     REAL(dp), ALLOCATABLE ::  yv(:)         !< coordinates of cell faces in y direction [m]
-    REAL(dp), ALLOCATABLE ::  zw(:)         !< coordinates of cell faces in z direction [m]
+    REAL(dp), POINTER     ::  zw(:)         !< coordinates of cell faces in z direction [m]
     REAL(dp), ALLOCATABLE ::  lat(:)        !< rotated-pole latitudes of scalars (cell centers) of the COSMO-DE grid [rad]
     REAL(dp), ALLOCATABLE ::  lon(:)        !< rotated-pole longitudes of scalars (cell centres) of the COSMO-DE grid [rad]
@@ -89,5 +112,5 @@
     REAL(dp), ALLOCATABLE ::  w_horiz(:,:,:)   !< weights for bilinear horizontal interpolation
     REAL(dp), ALLOCATABLE ::  w_verti(:,:,:,:) !< weights for linear vertical interpolation
- END TYPE
+ END TYPE grid_definition
 
 
@@ -103,5 +126,5 @@
     INTEGER               ::  dimvarids_soil(3)!< NetCDF IDs of the grid coordinates for soil points x, y, depth 
     REAL(dp), POINTER     ::  time(:)       ! vector of output time steps
- END TYPE
+ END TYPE nc_file
 
 
@@ -123,7 +146,7 @@
     CHARACTER(LEN=SNAME)                  ::  kind                      !< Kind of grid
     CHARACTER(LEN=SNAME)                  ::  task                      !< Processing task that generates this variable, e.g. 'interpolate_2d' or 'average profile'
-    LOGICAL                               ::  to_be_processed = .FALSE. !< Inifor flag indicating whether variable shall be processed
-    LOGICAL                               ::  is_read = .FALSE.         !< Inifor flag indicating whether variable has been read
-    LOGICAL                               ::  is_upside_down  = .FALSE. !< Inifor flag indicating whether variable shall be processed
+    LOGICAL                               ::  to_be_processed = .FALSE. !< INIFOR flag indicating whether variable shall be processed
+    LOGICAL                               ::  is_read = .FALSE.         !< INIFOR flag indicating whether variable has been read
+    LOGICAL                               ::  is_upside_down  = .FALSE. !< INIFOR flag indicating whether variable shall be processed
     TYPE(grid_definition), POINTER        ::  grid                      !< Pointer to the corresponding output grid
     TYPE(grid_definition), POINTER        ::  intermediate_grid         !< Pointer to the corresponding intermediate grid
Index: palm/trunk/UTIL/inifor/src/util.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/util.f90	(revision 3178)
+++ palm/trunk/UTIL/inifor/src/util.f90	(revision 3182)
@@ -21,4 +21,5 @@
 ! Current revisions:
 ! -----------------
+! Improved real-to-string conversion
 ! 
 ! 
@@ -43,5 +44,5 @@
         ONLY :  C_CHAR, C_INT, C_PTR, C_SIZE_T
     USE defs,                                                                  &
-        ONLY :  dp, PI, DATE
+        ONLY :  dp, PI, DATE, SNAME
 
     IMPLICIT NONE
@@ -279,5 +280,5 @@
     ! Convert a real number to a string in scientific notation
     ! showing four significant digits.
-    CHARACTER(LEN=11) FUNCTION real_to_str(val, format)
+    CHARACTER(LEN=SNAME) FUNCTION real_to_str(val, format)
 
         REAL(dp), INTENT(IN)                   ::  val
@@ -285,9 +286,9 @@
 
         IF (PRESENT(format))  THEN
-           WRITE(real_to_str, TRIM(format)) val
+           WRITE(real_to_str, format) val
         ELSE
            WRITE(real_to_str, '(E11.4)') val
-           real_to_str = ADJUSTL(real_to_str)
         END IF
+        real_to_str = ADJUSTL(real_to_str)
 
     END FUNCTION real_to_str
Index: palm/trunk/UTIL/inifor/tests/test-boundaries.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-boundaries.f90	(revision 3178)
+++ palm/trunk/UTIL/inifor/tests/test-boundaries.f90	(revision 3182)
@@ -21,4 +21,5 @@
 ! Current revisions:
 ! -----------------
+! Updated test for new PALM grid strechting
 ! 
 ! 
@@ -54,5 +55,6 @@
     TYPE(grid_definition)           ::  boundary_grid
 
-    REAL ::  dx, dy, dz, lx, ly, lz, x(2), y(10), z(10)
+    REAL ::  dx, dy, dz, lx, ly, lz, x(2), y(10)
+    REAL, TARGET :: z(10)
 
     CALL begin_test(title, res)
@@ -79,8 +81,7 @@
           xmin = x(i), xmax = x(i),                                            &
           ymin =  0.5 * dy, ymax = ly - 0.5 * dy,                              &
-          zmin =  0.5 * dz, zmax = lz - 0.5 * dz,                              &
           x0 = 0.0, y0 = 0.0, z0 = 0.0,                                        &
-          nx = 0, ny = ny, nz = nz,                                            &
-          dx = dx, dy = dy, dz = dz )
+          nx = 0, ny = ny, nz = nz, z = z)
+          
    
        ! Assert
@@ -103,5 +104,5 @@
     TYPE(grid_definition), INTENT(INOUT) ::  grid
 
-    DEALLOCATE( grid % x, grid % y, grid % z )
+    DEALLOCATE( grid % x, grid % y )
     DEALLOCATE( grid % kk )
     DEALLOCATE( grid % w_verti )
Index: palm/trunk/UTIL/inifor/tests/test-grid.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-grid.f90	(revision 3178)
+++ palm/trunk/UTIL/inifor/tests/test-grid.f90	(revision 3182)
@@ -21,4 +21,5 @@
 ! Current revisions:
 ! -----------------
+! Updated test for new PALM grid strechting
 ! 
 ! 
@@ -41,5 +42,5 @@
  PROGRAM test_grid
 
-    USE grid, ONLY :  grid_definition, init_grid_definition
+    USE grid, ONLY :  grid_definition, init_grid_definition, dx, dy, dz
     USE test_utils
     
@@ -49,35 +50,41 @@
     LOGICAL                     ::  res
 
-    TYPE(grid_definition) ::  mygrid
-    INTEGER               ::  i
-    INTEGER, PARAMETER    ::  nx = 9,   ny = 19,   nz = 29
-    REAL, PARAMETER       ::  lx = 100., ly = 200., lz = 300.
-    REAL, DIMENSION(0:nx) ::  x, xu
-    REAL, DIMENSION(0:ny) ::  y, yv
-    REAL, DIMENSION(0:nz) ::  z, zw
+    TYPE(grid_definition)   ::  mygrid
+    INTEGER                 ::  i
+    INTEGER, PARAMETER      ::  nx = 9,   ny = 19,   nz = 29
+    REAL, PARAMETER         ::  lx = 100., ly = 200., lz = 300.
+    REAL, DIMENSION(0:nx)   ::  x, xu
+    REAL, DIMENSION(0:ny)   ::  y, yv
+    REAL, DIMENSION(1:nz)   ::  z
+    REAL, DIMENSION(1:nz-1) ::  zw
 
     CALL begin_test(title, res)
 
     ! Arange
+    dx = lx / (nx + 1)
+    DO i = 0, nx
+       xu(i) = real(i) / (nx+1) * lx
+       x(i)  = 0.5*dx + xu(i)
+    END DO
+
+    dy = ly / (ny + 1)
+    DO i = 0, ny
+       yv(i) = real(i) / (ny+1) * ly
+       y(i)  = 0.5*dy + yv(i)
+    END DO
+
+    dz(:) = lz / (nz + 1)
+    DO i = 1, nz
+       IF (i < nz)  zw(i) = real(i) / (nz+1) * lz
+       z(i) = 0.5*dz(1) + zw(i)
+    END DO
+
+    ! Act
     CALL init_grid_definition('palm', grid = mygrid,                           &
                               xmin = 0., xmax = lx,                            &
                               ymin = 0., ymax = ly,                            &
-                              zmin = 0., zmax = lz,                            &
                               x0 = 0.0, y0 = 0.0, z0 = 0.0,                    &
-                              nx = nx, ny = ny, nz = nz)
-
-    ! Act
-    DO i = 0, nx
-       xu(i) = real(i) / (nx+1) * lx
-       x(i)  = 0.5*mygrid%dx + xu(i)
-    END DO
-    DO i = 0, ny
-       yv(i) = real(i) / (ny+1) * ly
-       y(i)  = 0.5*mygrid%dy + yv(i)
-    END DO
-    DO i = 0, nz
-       zw(i) = real(i) / (nz+1) * lz
-       z(i)  = 0.5*mygrid%dz + zw(i)
-    END DO
+                              nx = nx, ny = ny, nz = nz,                       &
+                              z = z, zw = zw)
 
     ! Assert coordinates match
@@ -85,7 +92,7 @@
     res = res .AND. assert_equal(xu(1:), mygrid%xu, "xu")
     res = res .AND. assert_equal(y,      mygrid%y,  "y" )
-    res = res .AND. assert_equal(yv(1:), mygrid%yv, "yu")
+    res = res .AND. assert_equal(yv(1:), mygrid%yv, "yv")
     res = res .AND. assert_equal(z,      mygrid%z,  "z" )
-    res = res .AND. assert_equal(zw(1:), mygrid%zw, "zu")
+    res = res .AND. assert_equal(zw(1:), mygrid%zw, "zw")
 
     CALL end_test(title, res)
Index: palm/trunk/UTIL/inifor/tests/test-input-files.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-input-files.f90	(revision 3178)
+++ palm/trunk/UTIL/inifor/tests/test-input-files.f90	(revision 3182)
@@ -21,5 +21,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! New test for negative start_hour and greater-than-one step_hour
+!
 ! 
 ! Former revisions:
@@ -44,13 +45,13 @@
         ONLY :  PATH
     USE grid,                                                                  & 
-        ONLY :  input_file_list
+        ONLY :  get_input_file_list
     USE test_utils
     
     IMPLICIT NONE
 
-    CHARACTER(LEN=50)                              ::  title
+    CHARACTER(LEN=60)                              ::  title
     CHARACTER(LEN=PATH), ALLOCATABLE, DIMENSION(:) ::  file_list, ref_list
     LOGICAL                                        ::  res
-    INTEGER                                        ::  i     
+    INTEGER                                        ::  i
 
     title = "input files - daylight saving to standard time"
@@ -70,8 +71,8 @@
 
     ! Act
-    CALL input_file_list(start_date_string='2017102823',                       &
-                         start_hour=0, end_hour=5, step_hour=1,                &
-                         path='./', prefix="laf", suffix='-test',              &
-                         file_list=file_list)
+    CALL get_input_file_list(start_date_string='2017102823',                   &
+                             start_hour=0, end_hour=5, step_hour=1,            &
+                             path='./', prefix="laf", suffix='-test',          &
+                             file_list=file_list)
 
     ! Assert
@@ -95,8 +96,38 @@
 
     ! Act
-    CALL input_file_list(start_date_string='2016022823',                       &
-                         start_hour=0, end_hour=1, step_hour=1,                &
-                         path='./', prefix="laf", suffix='-test',              &
-                         file_list=file_list)
+    CALL get_input_file_list(start_date_string='2016022823',                   &
+                             start_hour=0, end_hour=1, step_hour=1,            &
+                             path='./', prefix="laf", suffix='-test',          &
+                             file_list=file_list)
+
+    ! Assert
+    DO i = 1, 2
+       res = res .AND. (TRIM(ref_list(i)) .EQ. TRIM(file_list(i)))
+    END DO
+
+    DEALLOCATE( ref_list, file_list )
+    CALL end_test(title, res)
+
+
+
+    title = "input files - negative start_hour and step_hour > 1 hour"
+    CALL begin_test(title, res)
+
+    ! Arange
+    ! ...a date range that inlcudes a leap day (29. Feb. 2016) which should be
+    ! inlcuded in UTC time stamps.
+    ALLOCATE( ref_list(4) )
+    ref_list(1)  = './laf2017102823-test.nc'
+    ref_list(2)  = './laf2017102901-test.nc'
+    ref_list(3)  = './laf2017102903-test.nc'
+    ref_list(4)  = './laf2017102904-test.nc'
+
+    ! Act
+    CALL get_input_file_list(start_date_string='2017102901',                   &
+                             start_hour=-2, end_hour=3, step_hour=2,           &
+                             path='./', prefix="laf", suffix='-test',          &
+                             file_list=file_list)
+
+    PRINT *, file_list
 
     ! Assert
Index: palm/trunk/UTIL/inifor/tests/test-interpolation.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-interpolation.f90	(revision 3178)
+++ palm/trunk/UTIL/inifor/tests/test-interpolation.f90	(revision 3182)
@@ -21,5 +21,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Updated test for new grid_definition
+!
 ! 
 ! Former revisions:
@@ -76,5 +77,4 @@
                               xmin = -5.0 * TO_RADIANS, xmax = 5.5 * TO_RADIANS, &
                               ymin = -5.0 * TO_RADIANS, ymax = 6.5 * TO_RADIANS, &
-                              zmin =  0.0, zmax = 10.0,                        &
                               x0 = 0.0, y0 = 0.0, z0 = 0.0,                    &
                               nx = nlon-1, ny = nlat-1, nz = nlev-1)
@@ -86,5 +86,6 @@
     res = assert_equal( (/cosmo_grid%lat(0), cosmo_grid % lon(0),              &
                           cosmo_grid%lat(2), cosmo_grid % lon(2),              &
-                          cosmo_grid%dx*TO_DEGREES, cosmo_grid%dy*TO_DEGREES/),&
+                          (cosmo_grid%lon(1) - cosmo_grid%lon(0))*TO_DEGREES,  &
+                          (cosmo_grid%lat(1) - cosmo_grid%lat(0))*TO_DEGREES/),&
                         (/-5.0 * TO_RADIANS, -5.0 * TO_RADIANS,                &
                            6.5 * TO_RADIANS,  5.5 * TO_RADIANS,                &
@@ -97,5 +98,4 @@
                               xmin = 0.0, xmax = 1.0,                          &
                               ymin = 0.0, ymax = 1.0,                          &
-                              zmin = 0.0, zmax = 1.0,                          &
                               x0 = 0.0, y0 = 0.0, z0 = 0.0,                    &
                               nx = 1, ny = 1, nz = 1)
@@ -127,6 +127,6 @@
     ! Act
     CALL find_horizontal_neighbours(cosmo_grid % lat, cosmo_grid % lon,        &
-       cosmo_grid % dxi, cosmo_grid % dyi, palm_grid % clat, palm_grid % clon, &
-       palm_grid % ii, palm_grid % jj)
+                                    palm_grid % clat, palm_grid % clon,        &
+                                    palm_grid % ii, palm_grid % jj)
 
     ! Assert
@@ -178,10 +178,11 @@
     ! Act
     CALL find_horizontal_neighbours(cosmo_grid % lat, cosmo_grid % lon,        &
-       cosmo_grid % dxi, cosmo_grid % dyi, palm_grid % clat, palm_grid % clon, &
-       palm_grid % ii, palm_grid % jj)
+                                    palm_grid % clat, palm_grid % clon,        &
+                                    palm_grid % ii, palm_grid % jj)
 
     CALL compute_horizontal_interp_weights(cosmo_grid % lat, cosmo_grid % lon, &
-       cosmo_grid % dxi, cosmo_grid % dyi, palm_grid % clat,                   &
-       palm_grid % clon, palm_grid % ii, palm_grid % jj, palm_grid % w_horiz)
+                                           palm_grid % clat, palm_grid % clon, &
+                                           palm_grid % ii, palm_grid % jj,     &
+                                           palm_grid % w_horiz)
 
     ! Assert
Index: palm/trunk/UTIL/inifor/tests/test-prototype.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-prototype.f90	(revision 3178)
+++ palm/trunk/UTIL/inifor/tests/test-prototype.f90	(revision 3182)
@@ -21,5 +21,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added usage hints
 ! 
 ! Former revisions:
@@ -51,8 +51,11 @@
 
     ! Arange
+    !define parameters and reference values
 
     ! Act
+    !compute result
 
     ! Assert
+    !res = res .AND. assert_equal(<result_array>, <reference_array>, 'description')
 
     CALL end_test(title, res)
Index: palm/trunk/UTIL/inifor/tests/test-stretching.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-stretching.f90	(revision 3182)
+++ palm/trunk/UTIL/inifor/tests/test-stretching.f90	(revision 3182)
@@ -0,0 +1,97 @@
+!> @file tests/test-stretching.f90
+!------------------------------------------------------------------------------!
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
+! version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
+! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 2017-2018 Leibniz Universitaet Hannover
+! Copyright 2017-2018 Deutscher Wetterdienst Offenbach
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! Initial revision
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! 
+!
+! Authors:
+! --------
+! @author Eckhard Kadasch
+!
+! Description:
+! ------------
+!> This program tests INIFOR's implementation of PALM's grid stretching.
+!> 
+!------------------------------------------------------------------------------!
+ PROGRAM test_stretching
+
+    USE defs, &
+        ONLY :  dp
+
+    USE grid, &
+        ONLY :  stretched_z
+
+    USE test_utils
+    
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*), PARAMETER ::  title = "stretched grid"
+    LOGICAL                     ::  res
+
+    INTEGER, PARAMETER ::  nz = 9
+    INTEGER            ::  k  = nz - 2
+
+    REAL(dp) ::  z(1:nz)
+    REAL(dp) ::  dz(10)            = -1.0_dp
+    REAL(dp) ::  dz_max            = 1000.0_dp
+    REAL(dp) ::  dz_stretch_factor = 1.08_dp
+    REAL(dp) ::  dz_stretch_level  = 2.0_dp
+    REAL(dp) ::  dz_stretch_level_start(9) = -9999999.9_dp
+    REAL(dp) ::  dz_stretch_level_end(9) = 9999999.9_dp
+    REAL(dp) ::  dz_stretch_factor_array(9) = 1.08_dp
+
+    CALL begin_test(title, res)
+
+    ! Arange
+    z(:)   = 0.0_dp
+    dz(1)  = 1.0_dp
+
+    ! Act
+    CALL stretched_z(z, dz, dz_max=dz_max, &
+                     dz_stretch_factor=dz_stretch_factor,                   &
+                     dz_stretch_level=dz_stretch_level,                     &
+                     dz_stretch_level_start=dz_stretch_level_start,         &
+                     dz_stretch_level_end=dz_stretch_level_end,             &
+                     dz_stretch_factor_array=dz_stretch_factor_array)
+
+    ! Assert, that the total distance covered by the stretched region 
+    ! matches the therotetial distance, i.e. the sum over the finite
+    ! exponential series
+    !
+    !          Sum_{i=0}^n( dz[i] ) = dz[0] * Sum_{i=0}^n( f^i )
+    !                               = dz[0] * (1 - f^(i+1)) / (1-f)
+    !
+    ! with f being the stretch factor.
+    res = res .AND. &
+          assert_equal( (/ z(UBOUND(z, 1)) - z(1)              /),             &
+                        (/ (1.0_dp - dz_stretch_factor**(k+1)) /               &
+                           (1.0_dp - dz_stretch_factor)        /),             &
+                        'length of stretched grid' )
+
+    CALL end_test(title, res)
+
+ END PROGRAM test_stretching
